git-fetch.shon commit Merge fixes up to GIT 1.2.3 (2cf3be1)
   1#!/bin/sh
   2#
   3
   4USAGE='<fetch-options> <repository> <refspec>...'
   5. git-sh-setup
   6. git-parse-remote
   7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
   8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
   9
  10LF='
  11'
  12IFS="$LF"
  13
  14no_tags=
  15tags=
  16append=
  17force=
  18verbose=
  19update_head_ok=
  20exec=
  21upload_pack=
  22while case "$#" in 0) break ;; esac
  23do
  24        case "$1" in
  25        -a|--a|--ap|--app|--appe|--appen|--append)
  26                append=t
  27                ;;
  28        --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
  29        --upload-pa|--upload-pac|--upload-pack)
  30                shift
  31                exec="--exec=$1" 
  32                upload_pack="-u $1"
  33                ;;
  34        -f|--f|--fo|--for|--forc|--force)
  35                force=t
  36                ;;
  37        -t|--t|--ta|--tag|--tags)
  38                tags=t
  39                ;;
  40        -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
  41                no_tags=t
  42                ;;
  43        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  44        --update-he|--update-hea|--update-head|--update-head-|\
  45        --update-head-o|--update-head-ok)
  46                update_head_ok=t
  47                ;;
  48        -v|--verbose)
  49                verbose=Yes
  50                ;;
  51        -k|--k|--ke|--kee|--keep)
  52                keep=--keep
  53                ;;
  54        -*)
  55                usage
  56                ;;
  57        *)
  58                break
  59                ;;
  60        esac
  61        shift
  62done
  63
  64case "$#" in
  650)
  66        test -f "$GIT_DIR/branches/origin" ||
  67                test -f "$GIT_DIR/remotes/origin" ||
  68                        die "Where do you want to fetch from today?"
  69        set origin ;;
  70esac
  71
  72remote_nick="$1"
  73remote=$(get_remote_url "$@")
  74refs=
  75rref=
  76rsync_slurped_objects=
  77
  78if test "" = "$append"
  79then
  80        : >"$GIT_DIR/FETCH_HEAD"
  81fi
  82
  83append_fetch_head () {
  84    head_="$1"
  85    remote_="$2"
  86    remote_name_="$3"
  87    remote_nick_="$4"
  88    local_name_="$5"
  89    case "$6" in
  90    t) not_for_merge_='not-for-merge' ;;
  91    '') not_for_merge_= ;;
  92    esac
  93
  94    # remote-nick is the URL given on the command line (or a shorthand)
  95    # remote-name is the $GIT_DIR relative refs/ path we computed
  96    # for this refspec.
  97    case "$remote_name_" in
  98    HEAD)
  99        note_= ;;
 100    refs/heads/*)
 101        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
 102        note_="branch '$note_' of " ;;
 103    refs/tags/*)
 104        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
 105        note_="tag '$note_' of " ;;
 106    *)
 107        note_="$remote_name of " ;;
 108    esac
 109    remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
 110        remote_="$remote_1_"
 111    note_="$note_$remote_"
 112
 113    # 2.6.11-tree tag would not be happy to be fed to resolve.
 114    if git-cat-file commit "$head_" >/dev/null 2>&1
 115    then
 116        headc_=$(git-rev-parse --verify "$head_^0") || exit
 117        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
 118        [ "$verbose" ] && echo >&2 "* committish: $head_"
 119        [ "$verbose" ] && echo >&2 "  $note_"
 120    else
 121        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
 122        [ "$verbose" ] && echo >&2 "* non-commit: $head_"
 123        [ "$verbose" ] && echo >&2 "  $note_"
 124    fi
 125    if test "$local_name_" != ""
 126    then
 127        # We are storing the head locally.  Make sure that it is
 128        # a fast forward (aka "reverse push").
 129        fast_forward_local "$local_name_" "$head_" "$note_"
 130    fi
 131}
 132
 133fast_forward_local () {
 134    mkdir -p "$(dirname "$GIT_DIR/$1")"
 135    case "$1" in
 136    refs/tags/*)
 137        # Tags need not be pointing at commits so there
 138        # is no way to guarantee "fast-forward" anyway.
 139        if test -f "$GIT_DIR/$1"
 140        then
 141                if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
 142                then
 143                        [ "$verbose" ] && echo >&2 "* $1: same as $3"
 144                else
 145                        echo >&2 "* $1: updating with $3"
 146                fi
 147        else
 148                echo >&2 "* $1: storing $3"
 149        fi
 150        git-update-ref "$1" "$2" 
 151        ;;
 152
 153    refs/heads/*)
 154        # $1 is the ref being updated.
 155        # $2 is the new value for the ref.
 156        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 157        if test "$local"
 158        then
 159            # Require fast-forward.
 160            mb=$(git-merge-base "$local" "$2") &&
 161            case "$2,$mb" in
 162            $local,*)
 163                echo >&2 "* $1: same as $3"
 164                ;;
 165            *,$local)
 166                echo >&2 "* $1: fast forward to $3"
 167                git-update-ref "$1" "$2" "$local"
 168                ;;
 169            *)
 170                false
 171                ;;
 172            esac || {
 173                echo >&2 "* $1: does not fast forward to $3;"
 174                case ",$force,$single_force," in
 175                *,t,*)
 176                        echo >&2 "  forcing update."
 177                        git-update-ref "$1" "$2" "$local"
 178                        ;;
 179                *)
 180                        echo >&2 "  not updating."
 181                        ;;
 182                esac
 183            }
 184        else
 185            echo >&2 "* $1: storing $3"
 186            git-update-ref "$1" "$2"
 187        fi
 188        ;;
 189    esac
 190}
 191
 192case "$update_head_ok" in
 193'')
 194        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 195        ;;
 196esac
 197
 198# If --tags (and later --heads or --all) is specified, then we are
 199# not talking about defaults stored in Pull: line of remotes or
 200# branches file, and just fetch those and refspecs explicitly given.
 201# Otherwise we do what we always did.
 202
 203reflist=$(get_remote_refs_for_fetch "$@")
 204if test "$tags"
 205then
 206        taglist=$(IFS=" " &&
 207                  git-ls-remote $upload_pack --tags "$remote" |
 208                  while read sha1 name
 209                  do
 210                        case "$name" in
 211                        (*^*) continue ;;
 212                        esac
 213                        if git-check-ref-format "$name"
 214                        then
 215                            echo ".${name}:${name}"
 216                        else
 217                            echo >&2 "warning: tag ${name} ignored"
 218                        fi
 219                  done)
 220        if test "$#" -gt 1
 221        then
 222                # remote URL plus explicit refspecs; we need to merge them.
 223                reflist="$reflist$LF$taglist"
 224        else
 225                # No explicit refspecs; fetch tags only.
 226                reflist=$taglist
 227        fi
 228fi
 229
 230fetch_main () {
 231  reflist="$1"
 232  refs=
 233
 234  for ref in $reflist
 235  do
 236      refs="$refs$LF$ref"
 237
 238      # These are relative path from $GIT_DIR, typically starting at refs/
 239      # but may be HEAD
 240      if expr "$ref" : '\.' >/dev/null
 241      then
 242          not_for_merge=t
 243          ref=$(expr "$ref" : '\.\(.*\)')
 244      else
 245          not_for_merge=
 246      fi
 247      if expr "$ref" : '\+' >/dev/null
 248      then
 249          single_force=t
 250          ref=$(expr "$ref" : '\+\(.*\)')
 251      else
 252          single_force=
 253      fi
 254      remote_name=$(expr "$ref" : '\([^:]*\):')
 255      local_name=$(expr "$ref" : '[^:]*:\(.*\)')
 256
 257      rref="$rref$LF$remote_name"
 258
 259      # There are transports that can fetch only one head at a time...
 260      case "$remote" in
 261      http://* | https://*)
 262          if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 263              curl_extra_args="-k"
 264          fi
 265          remote_name_quoted=$(perl -e '
 266              my $u = $ARGV[0];
 267              $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
 268              print "$u";
 269          ' "$remote_name")
 270          head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
 271          expr "$head" : "$_x40\$" >/dev/null ||
 272                  die "Failed to fetch $remote_name from $remote"
 273          echo >&2 Fetching "$remote_name from $remote" using http
 274          git-http-fetch -v -a "$head" "$remote/" || exit
 275          ;;
 276      rsync://*)
 277          TMP_HEAD="$GIT_DIR/TMP_HEAD"
 278          rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 279          head=$(git-rev-parse --verify TMP_HEAD)
 280          rm -f "$TMP_HEAD"
 281          test "$rsync_slurped_objects" || {
 282              rsync -av --ignore-existing --exclude info \
 283                  "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 284
 285              # Look at objects/info/alternates for rsync -- http will
 286              # support it natively and git native ones will do it on
 287              # the remote end.  Not having that file is not a crime.
 288              rsync -q "$remote/objects/info/alternates" \
 289                  "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 290                  rm -f "$GIT_DIR/TMP_ALT"
 291              if test -f "$GIT_DIR/TMP_ALT"
 292              then
 293                  resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 294                  while read alt
 295                  do
 296                      case "$alt" in 'bad alternate: '*) die "$alt";; esac
 297                      echo >&2 "Getting alternate: $alt"
 298                      rsync -av --ignore-existing --exclude info \
 299                      "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 300                  done
 301                  rm -f "$GIT_DIR/TMP_ALT"
 302              fi
 303              rsync_slurped_objects=t
 304          }
 305          ;;
 306      *)
 307          # We will do git native transport with just one call later.
 308          continue ;;
 309      esac
 310
 311      append_fetch_head "$head" "$remote" \
 312          "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 313
 314  done
 315
 316  case "$remote" in
 317  http://* | https://* | rsync://* )
 318      ;; # we are already done.
 319  *)
 320    ( : subshell because we muck with IFS
 321      IFS="     $LF"
 322      (
 323          git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
 324      ) |
 325      while read sha1 remote_name
 326      do
 327          case "$sha1" in
 328          failed)
 329                  echo >&2 "Fetch failure: $remote"
 330                  exit 1 ;;
 331          esac
 332          found=
 333          single_force=
 334          for ref in $refs
 335          do
 336              case "$ref" in
 337              +$remote_name:*)
 338                  single_force=t
 339                  not_for_merge=
 340                  found="$ref"
 341                  break ;;
 342              .+$remote_name:*)
 343                  single_force=t
 344                  not_for_merge=t
 345                  found="$ref"
 346                  break ;;
 347              .$remote_name:*)
 348                  not_for_merge=t
 349                  found="$ref"
 350                  break ;;
 351              $remote_name:*)
 352                  not_for_merge=
 353                  found="$ref"
 354                  break ;;
 355              esac
 356          done
 357          local_name=$(expr "$found" : '[^:]*:\(.*\)')
 358          append_fetch_head "$sha1" "$remote" \
 359                  "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 360      done
 361    ) || exit ;;
 362  esac
 363
 364}
 365
 366fetch_main "$reflist"
 367
 368# automated tag following
 369case "$no_tags$tags" in
 370'')
 371        case "$reflist" in
 372        *:refs/*)
 373                # effective only when we are following remote branch
 374                # using local tracking branch.
 375                taglist=$(IFS=" " &&
 376                git-ls-remote $upload_pack --tags "$remote" |
 377                sed -ne 's|^\([0-9a-f]*\)[      ]\(refs/tags/.*\)^{}$|\1 \2|p' |
 378                while read sha1 name
 379                do
 380                        test -f "$GIT_DIR/$name" && continue
 381                        git-check-ref-format "$name" || {
 382                                echo >&2 "warning: tag ${name} ignored"
 383                                continue
 384                        }
 385                        git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
 386                        echo >&2 "Auto-following $name"
 387                        echo ".${name}:${name}"
 388                done)
 389        esac
 390        case "$taglist" in
 391        '') ;;
 392        ?*)
 393                fetch_main "$taglist" ;;
 394        esac
 395esac
 396
 397# If the original head was empty (i.e. no "master" yet), or
 398# if we were told not to worry, we do not have to check.
 399case ",$update_head_ok,$orig_head," in
 400*,, | t,* )
 401        ;;
 402*)
 403        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 404        if test "$curr_head" != "$orig_head"
 405        then
 406                git-update-ref HEAD "$orig_head"
 407                die "Cannot fetch into the current branch."
 408        fi
 409        ;;
 410esac